/*
---
description: Event.realChange

license: MIT-style

authors:
- Hugo Mougard

requires:
- Element
- Element.Event

provides: [Element.Events.realChange]

...
*/

(function() {
Element.Properties.realChange = {
get: function() {
return this.retrieve('_realChangeEvents');
},
set: function(events) {
this.store('_realChangeEvents', $splat(events));
return this;
}
};
Element.Events.realChange = {
'base' : 'click',
condition : $lambda(false),
onAdd : function() {
if (this.retrieve('_realChangeRunning')) return this;
this.store('_realChangeRunning', true);
this.store('_realChangeValue', this.get('value'));
var self = this,
fire = function() {
var value = self.get('value');
if(value !== self.retrieve('_realChangeValue')) {
self.fireEvent('realChange', value);
self.store('_realChangeValue', self.get('value'));
}
},
events = this.get('realChange');
if (! events)
this.set('realChange', events = ['keyup', 'click']);
this.store('_realChangeFire', fire);
events.each(function(event) {
self.addEvent(event, fire);
});
return this;
},
onRemove: function() {
if (! this.retrieve('events').realChange.keys
||
this.retrieve('events').realChange.keys.length === 0) {
var fire = this.retrieve('_realChangeFire'),
self = this;
this.get('realChange').each(function(event){
self.removeEvent(event, fire);
});
}
}
}
})();